emulated_window = (function()
{

	var ew = {};

	var workArea = {
	};

	ew.setWorkArea = function(canvas) {
		workArea = {
			"canvas" : canvas,
			"ctx" : canvas.getContext("2d") 
		};	
	};
	
	var setFont = function(structure) {
		var font = "";
		if (structure.fontDetails.bold) {
			font += "bold ";
		}
		if (structure.fontDetails.italic) {
			font += "italic ";
		}
		var fontSize = structure.fontDetails.size;
		if (structure.fontDetails.legacyHeight != undefined && structure.fontDetails.legacyHeight > 0) {
			fontSize = structure.fontDetails.legacyHeight;
		}
		font += " " + fontSize + "pt";
		font += " '" + structure.fontDetails.name + "'";
		workArea.ctx.font = font;	
	};

	ew.setFont = setFont;

	var measureText = function(text) {
		return workArea.ctx.measureText(text).width;		
	};

	ew.getFontMetrics = {
		"charWidth" : measureText,
		"stringWidth" : measureText
	};

	ew.drawString = function(structure) {
		
		setFont(structure);
		workArea.ctx.fillText(structure.text, structure.x, structure.y);
	};

	ew.drawStringScaled = function(structure) {
		setFont(structure);
		// measure the text width for the new fontSize the calculate widthScale		
		var textWidth = measureText(structure.text);		
		var widthScale = structure.fontDetails.legacyWidth / textWidth;
		// scale drawing context to computed width, keepig height
		// this scales the desired structure.x as well so it needs adjusting
		workArea.ctx.scale(widthScale, 1);
		var scaleBack = 1 / widthScale;
		workArea.ctx.fillText(structure.text, structure.x * scaleBack, structure.y);
		workArea.ctx.scale(scaleBack, 1);
	}

	return ew;

}())
